/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package business;

import domain.Product;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.EJBException;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.interceptor.Interceptors;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import javax.transaction.HeuristicMixedException;
import javax.transaction.HeuristicRollbackException;
import javax.transaction.NotSupportedException;
import javax.transaction.RollbackException;
import javax.transaction.SystemException;
import javax.transaction.UserTransaction;

/**
 *
 * @author hardebolle
 */
@Stateless
@TransactionManagement(TransactionManagementType.CONTAINER)
@TransactionAttribute(TransactionAttributeType.NEVER)
//@TransactionManagement(TransactionManagementType.BEAN)
public class CatalogFacade {

    @PersistenceContext(unitName = "cqpasiPU")
    private EntityManager em;

    
//    @Resource
//    private UserTransaction utx;

    public List<Product> getProductList() {
        TypedQuery<Product> q = this.em.createNamedQuery("getAllProducts", Product.class);
        return q.getResultList();
    }

    @TransactionAttribute(TransactionAttributeType.REQUIRED)
    public void add(Product p) {
//        try {
//            utx.begin();
//            System.out.println(utx);
            if (p != null) {
                this.em.persist(p);
            }
//            utx.commit();
//        } catch (Exception e) {
//            try {
//                utx.rollback();
//            } catch (SystemException syex) {
//                throw new EJBException("Rollback failed: " + syex.getMessage());
//            }
//            throw new EJBException("Transaction failed: " + e.getMessage());
//
//        }
    }
    
    @TransactionAttribute(TransactionAttributeType.REQUIRED)
    public void delete(Product p) {
        if (p != null) {
            this.em.remove(this.em.merge(p));
        }
    }

    @TransactionAttribute(TransactionAttributeType.REQUIRED)
    public void edit(Product p) {
        if (p != null) {
            this.em.merge(p);
        }
    }
}
